=== debian/changelog ===
nnn (4.3-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump Standards-Version to 4.6.0.1

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 30 Sep 2021 14:55:51 +0800

nnn (4.2-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump Standards-Version to 4.5.1
  * d/tests:
    - Redirect stderr output for parsing testing string

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 05 Sep 2021 16:29:45 +0800
