=== debian/control ===
Source: nnn
Section: misc
Priority: optional
Maintainer: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: debhelper-compat (= 13),
               libncurses-dev,
               libreadline-dev,
               pkg-config
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://github.com/jarun/nnn
Vcs-Git: https://salsa.debian.org/debian/nnn.git
Vcs-Browser: https://salsa.debian.org/debian/nnn

Package: nnn
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         readline-common
Suggests: mediainfo | exiftool,
          atool | patool,
          vlock,
          file,
          lftp,
          sshfs,
          xdg-utils
Description: Free, fast, friendly file manager
 nnn is a fork of noice, a blazing-fast lightweight terminal file manager
 with easy keyboard shortcuts for navigation, opening files and running tasks.
 nnn toppings
 .
  - Show details of the currently selected file (stat, file)
  - Disk usage analyzer mode (within the same fs, doesn't follow symlinks)
  - Directories first (even with sorting)
  - Sort numeric names in numeric order
  - Case-insensitive alphabetic content listing instead of upper case first
  - Key - to jump to last visited directory
  - Roll over at the first and last entries of a directory
  - Removed navigation restriction with relative paths
  - Sort entries by file size (largest to smallest)
  - Shortcut to invoke file name copier
