=== debian/changelog ===
nnn (4.5-1) unstable; urgency=medium

  * Import new upstrem version
  * Update copyright

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 27 Apr 2022 10:03:59 +0800

nnn (4.4-1) unstable; urgency=medium

  * Import new upstrem version
  * Update copyright

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 05 Dec 2021 21:34:15 +0800
