=== debian/changelog ===
nnn (4.7-1) unstable; urgency=medium

  * Import new upstrem version
  * d/watch:
    - Fix format issue (Closes:#1024777)

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 03 Dec 2022 22:49:54 +0800

nnn (4.6-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.6.1.0

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 19 Aug 2022 12:18:36 +0800
