=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
