## nnn 4.8

=== debian/changelog ===
nnn (4.8-1) stable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Tue, 30 Sep 2025 23:39:54 +0000

nnn (4.8) stable; urgency=low

- nnn v4.8 Spritz release notes.

  * show total size (key S) of non-filtered selection in a directory
  * fix tilde (~) handling in file name
  * plugin .nmv now respects -u flag
  * env var $NNN_PREFER_SELECTION exported to all plugins
  * support for wezterm in preview-tui
  * create new file or directory (tree) on startup
  * run command as plugin now supports exported variables
  * use "$nnn" anywhere when running command as plugin
  * set defaults for some prompts on Enter
  * improve archive, rename and create new workflows
  * optimize link creation
  * allow overwriting regular files on new empty file creation
  * add patch for colemak keyboard (existing renamed to colemak-dh)
  * add correct check for Wayland in clipboard plugins
  * add quitcd script for nushell
  * plugin kdeconnect - send multiple files
  * plugin preview-tui: add chafa as preferred image viewer, multiple fixes
  * plugin nmount - misc. improvements
  * add icon for jxl files
  * Modify correct copyright years

  -- Nicolas FORMICHELLA <stigpro@outlook.fr> Fri, 14 Apr 13:00:00 +0000

nnn (4.7) stable; urgency=low

-nnn v4.7 Cuba libre release notes.

  * fix ^N not working sometimes (#1449)
  * fix file remove confirmation prompt [Esc - cancel, y/Y - use force, any other key - prompt for each file]
  * bring back atool as the default archive handler
  * add option -B to use bsdtar as the archive utility
  * find and list mode improvements
    * continue even if max paths/data size limit is exceeded
    * speed improvements
    * support listing maximum 16K paths of 64 MiB of data
  * key J to jump to an entry or relative offset from current entry
  * prefill the hard link creation prompt when there's a single target (#1507)
  * documented workaround for docker container crash (#1407, #1476)
  * plugin imgview: handle arguments as strings (#1509)
  * plugin wallpaper: support Wayland (#1512)
  * plugin upload: handle selection using ffsend (#1523)
  * add Rust icons (#1502)

  -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.6) stable; urgency=low

  * icon handling overhaul for better performance, memory usage and reduced binary size (#1432, #1436)
  * emoji support for supporting distros and terminals (#1346)
  * open the target directory of symlinked bookmarks (#1353)
  * enable show hidden when a hidden file is passed as argument
  * add Colemak-DH layout keybinds to patch framework (#1421)
  * set bsdtar as the default archive utility
  * support 4 byte unicode keybinds (#1428)
  * enable directory auto-enter during filter operation (-A to disable)
  * enable filter prompt inside the bookmark/plugin dirs
  * show volume usage information in help
  * add Elixir icons (#1437)
  * add new icon colors for mp4 and flac files
  * use stat -x for file details on *BSD and macOS (#1389)
  * interpret suffix $nnn when paging (#1355)
  * disable key e (edit file) in explorer mode (#1394)
  * fix double order chars on filter case match change
  * .cbcp: more verbose message on paste without a selection
  * plugin preview-tui: scale-up kitty previews
  * plugin preview-tui: account for ueberzug offset
  * plugin preview-tui: support SPLIT_SIZE for preview pane (#1431)
  * plugin autojump: support z.lua
  * new Makefile target shellcheck to verify plugins

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.5) stable; urgency=low

  * Prepare for release v4.5 Cachaça
  * Fix patch conflicts and rebase
  * Use bold forward arrowhead for current
  * Add 2 spaces after icons for better visibility
  * Fix #1345: allow symlink name '@' in single file case
  * quitcd script for Elvish shell > 0.17.0
  * Handle broken window if started in type-to-nav
  * Bind ^J with toggle auto-jump on open
  * Replace ^J with + to (un)select
  * consistently use ELEMENTS macro

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.4) stable; urgency=low

- support macOS iterm2 in plugin preview-tui (#1196)
- use selection at native command prompt with %j and %J (docs)
- scroll strings longer than columns in rename/new prompts (#1213, #279)
- batch rename symlink targets in listing mode (#1214)
- option for recursive rename in plugin .nmv (#1186)
- more frequent checks for cancellation during du (#1236)
- picker mode: enable auto-proceed
- picker mode: don't pick hovered file on Enter if selection exists
- picker mode: fix issue in plugin fzopen when used to pick files
- send file to explorer FIFO on double left click instead of opening it
- new neovim plugin nnn.nvim featuring explorer mode
- explorer mode for nnn.vim
- remove option -w: always place HW cursor on current entry
- accept link name when linking a single target (#1201)
- option -i to show current file information in info bar
- force GNU sed on *BSD and Solaris
- add nsxiv support to nuke, preview-tabbed and imgview (#1230)
- fix preview-tui without -a (#1208)
- pass pts in env var for preview-tui to use in tput (#1235)
- disable editing file in picker mode (#1183)
- save session in picker mode (#1190)
- use nerd icons for gitstatus patch (#1220)

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 24 Now 2021 07:00:00 +0100

nnn (4.3-1) stable; urgency=low

  * Added completions

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 29 Sep 2021 22:21:00 +022

nnn (4.3) stable; urgency=low

  *    cool ASCII art logo in the help screen
  *    add bookmarks directory for flexible symlinked bookmarks
  *    new key B to add a symlinked bookmark for current dir
  *    special variables $dN, $fN available for plugins/prompt/shell to access per-context dir/hovered file
  *    config NNN_ORDER to set directory-specific ordering
  *    show/hide hidden files as per context state in plugin based batch rename

