=== debian/control ===
Source: nnn
Section: utilities
Priority: optional
Maintainer: Nicolas FORMICHELLA <stigpro@outlook.fr>
Build-Depends: debhelper (>= 9), pkg-config, make, gcc, libreadline-dev | libreadline6-dev, libncurses-dev | libncursesw5-dev

Package: nnn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The unorthodox terminal file manager
