=== debian/rules ===
#!/usr/bin/make -f
# vim: syntax=make
#export DH_VERBOSE = 1

VERSION := 4.8

export DESTROOT=$(CURDIR)/debian

DEB_TARGET_GNU_CPU ?= $(DEB_BUILD_GNU_CPU)

%:
	dh $@

override_dh_auto_clean:

override_dh_auto_build:
	make strip

override_dh_auto_install:
	mkdir -p $(DESTROOT)/nnn/usr/bin
	cp nnn $(DESTROOT)/nnn/usr/bin
	mkdir -p $(DESTROOT)/usr/share/bash-completion/completions/
	mkdir -p $(DESTROOT)/usr/share/fish/vendor_completions.d/
	mkdir -p $(DESTROOT)/usr/share/zsh/site-functions/
	install -Dm0644 misc/auto-completion/fish/nnn.fish $(DESTROOT)/usr/share/fish/vendor_completions.d/nnn.fish
	install -Dm0644 misc/auto-completion/bash/nnn-completion.bash $(DESTROOT)/usr/share/bash-completion/completions/nnn
	install -Dm0644 misc/auto-completion/zsh/_nnn $(DESTROOT)/usr/share/zsh/site-functions/_nnn
