=== debian/changelog ===
nnn (4.9-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:46 +1100

nnn (4.9-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:58:54 +0100

nnn (4.9-1) unstable; urgency=medium

  * Import new upstrem version

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 10 Sep 2023 20:12:40 +0800

nnn (4.8-1) unstable; urgency=medium

  * Import new upstrem version
  * Update d/copyright
  * d/control:
    - Bump Standards-Version to 4.6.2

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 16 Jul 2023 17:21:36 +0800
