## nnn 5.0

=== debian/changelog ===
nnn (5.0-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.7.0

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 02 Sep 2024 14:37:24 +0800
