=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: nnn
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: SZ Lin (林上智) <szlin@debian.org>
+Maintainer: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
                libreadline-dev,
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
