## nnn 5.1

=== Makefile ===
--- 
+++ 
@@ -32,10 +32,11 @@
 
 # User patches
 O_COLEMAK := 0 # change key bindings to colemak compatible layout
-O_COLEMAK-DH := 0 # change key bindings to colemak-dh compatible layout
 O_GITSTATUS := 0 # add git status to detail view
 O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view
 O_RESTOREPREVIEW := 0 # add preview pipe to close and restore preview pane
+
+T_ICONS := 0 # test if multiple icons options are set and fail
 
 # convert targets to flags for backwards compatibility
 ifneq ($(filter debug,$(MAKECMDGOALS)),)
@@ -98,16 +99,28 @@
 ifeq ($(strip $(O_ICONS)),1)
 	ICONS_INCLUDE = icons-generated-icons-in-term.h
 	CPPFLAGS += -DICONS_IN_TERM -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_NERD)),1)
 	ICONS_INCLUDE = icons-generated-nerd.h
 	CPPFLAGS += -DNERD -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_EMOJI)),1)
 	ICONS_INCLUDE = icons-generated-emoji.h
 	CPPFLAGS += -DEMOJI -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_QSORT)),1)
@@ -169,7 +182,6 @@
 LOGO64X64 = misc/logo/logo-64x64.png
 
 COLEMAK = patches/colemak
-COLEMAK-DH = patches/colemak-dh
 GITSTATUS = patches/gitstatus
 NAMEFIRST = patches/namefirst
 RESTOREPREVIEW = patches/restorepreview
@@ -342,14 +354,7 @@
 ifeq ($(strip $(O_COLEMAK)),1)
 	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK)/mainline.diff
 endif
-ifeq ($(strip $(O_COLEMAK-DH)),1)
-	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK-DH)/mainline.diff
-endif
 
 postpatch:
 ifeq ($(strip $(O_NAMEFIRST)),1)
 ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/namefirst.diff
-endif
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(NAMEFIRST)/mainline.diff
-else ifeq ($(strip $(O_GITSTATUS)),1)
