=== debian/changelog ===
nnn (5.1-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.7.2
  * d/copyright:
    - Update d/copyright year
  * d/watch:
    - Remove the option filenamemangle
  * d/rules:
    - Fix tbl preprocessor failed

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 15 Aug 2025 21:53:52 +0800
