=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkgconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
