=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:

override_dh_missing:
	dh_missing --fail-missing

override_dh_installman:
	tbl nnn.1 > debian/nnn.1.tmp
	mv debian/nnn.1.tmp nnn.1
	dh_installman
